﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Add_AddUnique_Method
{
    [Serializable]
    class UniqueStocksList<T> : List<T> where T : Stocks
    //class UniqueStocksList : List<Stocks>
    {
        public enum UniqueKey
        {
            Symbol,
            Name
        }

        private UniqueKey _UniqueKey;

        public UniqueStocksList(UniqueKey UK)
        {
            _UniqueKey = UK;
        }

        //public bool AddUnique(Stocks item)  // Fonctione avec  class UniqueStocksList<T> : List<T> where T:Stocks
        public bool AddUnique(T item)  // Fonctione avec  class UniqueStocksList<T> : List<T> where T:Stocks
        {
            switch (_UniqueKey)
            {
                case UniqueKey.Symbol:
                    if (!this.Exists(x => x.Symbol == item.Symbol))
                    {
                        this.Add(item);
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                //break;
                case UniqueKey.Name:
                    if (!this.Exists(x => x.Name == item.Name))
                    {
                        this.Add(item);
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                //break;
                default:
                    return false;
                    //break;
            }
        }

    }
}
